var stream1Names;
var stream1URLs;
var stream2Names;
var stream2URLs;
var currentStreamID;


window.onload = function()
{
	var currentStream = System.Gadget.Settings.readString("streamName");
	var currentID = 0;

	loadStreamList();
	
	if (currentStream != "") {
		currentID = getIDByStreamName(currentStream);
	}
	
	if (currentID >= 0 && currentID < stream1Names.length)
		currentStreamID = currentID;
	else
		currentStreamID = 0;
	
	System.Gadget.onSettingsClosing = settingsClosing;
	
	generateStreamList1(Radio1Streams);
	generateStreamList2(Radio2Streams);
	
}


function getIDByStreamName(streamName)
{
	for (i=0;i<stream1Names.length;i++)
	{
		if (stream1Names[i] == streamName)
			return i;
	}

	for (i=0;i<stream2Names.length;i++)
	{
		if (stream2Names[i] == streamName)
			return i;
	}
	return -1;
}

function stream1Change()
{
	System.Gadget.Settings.write("station", 1);
	System.Gadget.Settings.writeString("streamName", stream1Names[CBCstream1.value]);
}

function stream2Change()
{
	// station: 1=Radio One, 2=Radio 2, 3=RCI, 4=Radio 3
	// 		used to set the background image
	if (stream2Names[CBCstream2.value] == "Radio 3")
		System.Gadget.Settings.write("station", 4);
	else if (stream2Names[CBCstream2.value] == "Radio3 Rock")
		System.Gadget.Settings.write("station", 4);
	else if (stream2Names[CBCstream2.value] == "Radio3 Elct")
		System.Gadget.Settings.write("station", 4);
	else if (stream2Names[CBCstream2.value] == "Radio3 Hphp")
		System.Gadget.Settings.write("station", 4);
	else if (stream2Names[CBCstream2.value] == "Radio3 Pop")
		System.Gadget.Settings.write("station", 4);
	else
	{
		if (stream2Names[CBCstream2.value] == "RC Int.") 
		System.Gadget.Settings.write("station", 3);
		else
		System.Gadget.Settings.write("station", 2);
	}
	System.Gadget.Settings.writeString("streamName", stream2Names[CBCstream2.value]);
}

function settingsClosing(event)
{
	if (event.closeAction == event.Action.commit) 
	{
//		if (station = 1)
//			System.Gadget.Settings.writeString("streamName", stream1Names[CBCstream1.value]);
//		else
//			System.Gadget.Settings.writeString("streamName", stream2Names[CBCstream2.value]);
	}
	
	event.cancel = false;
}

function generateStreamList1(parentObj)
{
	var strHTML = "<select NAME='stream1' id='CBCstream1' onClick='stream1Change()' style='width: 235;' >";
	var stream1Count = System.Gadget.Settings.read("stream1Count");

		for (i=0;i<stream1Count;i++)
		{
			if (i == currentStreamID)
				strHTML += ("<option VALUE='" + i.toString() + "' SELECTED>" + stream1Names[i]);
			else
				strHTML += ("<option VALUE='" + i.toString() + "'>" + stream1Names[i]);
		}

	strHTML += "</select>";
	parentObj.innerHTML = strHTML;
}

function generateStreamList2(parentObj)
{
	var strHTML = "<select NAME='stream2' id='CBCstream2' onClick='stream2Change()' style='width: 235;'>";
	var stream2Count = System.Gadget.Settings.read("stream2Count");

		for (i=0;i<stream2Count;i++)
		{
			if (i == currentStreamID)
				strHTML += ("<option VALUE='" + i.toString() + "' SELECTED>" + stream2Names[i]);
			else
				strHTML += ("<option VALUE='" + i.toString() + "'>" + stream2Names[i]);
		}
	
	strHTML += "</select>";
	parentObj.innerHTML = strHTML;
}

function loadStreamList()
{
	stream1Names = new Array();
	stream1URLs = new Array();
	stream2Names = new Array();
	stream2URLs = new Array();

	var stream1Count = System.Gadget.Settings.read("stream1Count");
	var stream2Count = System.Gadget.Settings.read("stream2Count");
	if (stream1Count > 0) 
	{
		for (i=0;i<stream1Count;i++)
		{
			stream1Names[i] = System.Gadget.Settings.readString("stream1"+i.toString());
			stream1URLs[i]  = System.Gadget.Settings.readString("url1"+i.toString());
		}
	}
	else
	{
		alert("Empty Radio One list, please relaunch iCBC player.");
	}

	if (stream2Count > 0) 
	{
		for (i=0;i<stream2Count;i++)
		{
			stream2Names[i] = System.Gadget.Settings.readString("stream2"+i.toString());
			stream2URLs[i]  = System.Gadget.Settings.readString("url2"+i.toString());
		}
	}
	else
	{
		alert("Empty Radio 2 list, please relaunch iCBC player.");
	}
}