var stream1Names;
var stream2Names;
var stream1URLs;
var stream2URLs;
var currentStream;

function loadMain()
{	
	loadStreamList();
	loadCurrentStream();
	dockStateChange();		// refresh everytime Sidebar.exe relaunches
						// controlImage.src = "images/play_sm.png"
	controlImageMouse(false);	// Refresh image

	System.Gadget.onDock = dockStateChange;
	System.Gadget.onUndock = dockStateChange;
    
	System.Gadget.settingsUI = "Settings.html";
	System.Gadget.onSettingsClosed = settingsClosed;
}

function loadCurrentStream()
{
	var tempName = System.Gadget.Settings.readString("streamName");
	var currentURL = "";
	
	if (tempName != "")
	{
		currentURL = getURLByStreamName(tempName);
	}
	
	if (currentURL == "") // set a default stream at startup
	{
		currentStream = stream2Names[1];
		currentURL = stream2URLs[1];
		System.Gadget.Settings.write("station", 2);
		System.Gadget.Settings.writeString("streamName", stream2Names[1]);
	}
	else
	{
		currentStream = tempName;
	}
	
	setMediaPlayer(currentURL);
}

function getURLByStreamName(streamName)
{
	for (i=0;i<stream1Names.length;i++)
	{
		if (stream1Names[i] == streamName)
			return stream1URLs[i];
	}

	for (i=0;i<stream2Names.length;i++)
	{
		if (stream2Names[i] == streamName)
			return stream2URLs[i];
	}
	return "";
}

function setMediaPlayer(streamURL)
{
	mediaPlayer.url = streamURL;

	var nowPlayingText = "<div id='nowPlayingText'><font color='black'><b>" + currentStream + " </b></font></div>";
	nowPlaying.innerHTML = nowPlayingText;
}

function initStreamList1()
{
	stream1Names = new Array();
	stream1URLs = new Array();

	stream1Names[0] = "Calgary";
	stream1URLs[0]  = "http://icy1.abacast.com/cbc-r1calgary-96.m3u";
	
	stream1Names[1] = "Charlotetwn";
	stream1URLs[1]  = "http://icy1.abacast.com/cbc-r1charlottetown-96.m3u";
	
	stream1Names[2] = "Cornerbrook";
	stream1URLs[2]  = "http://icy1.abacast.com/cbc-r1cornerbrook-96.m3u";

	stream1Names[3] = "Edmonton";
	stream1URLs[3]  = "http://icy1.abacast.com/cbc-r1edmonton-96.m3u";

	stream1Names[4] = "Fredericton";
	stream1URLs[4]  = "http://icy1.abacast.com/cbc-r1fredericton-96.m3u";
	
	stream1Names[5] = "Grand Falls";
	stream1URLs[5]  = "http://icy1.abacast.com/cbc-r1grandfalls-96.m3u";

	stream1Names[6] = "Halifax";
	stream1URLs[6]  = "http://icy1.abacast.com/cbc-r1halifax-96.m3u";

	stream1Names[7] = "Inuvik";
	stream1URLs[7]  = "http://icy1.abacast.com/cbc-r1inuvik-96.m3u";

	stream1Names[8] = "Iqaluit";
	stream1URLs[8]  = "http://icy1.abacast.com/cbc-r1iqaluit-96.m3u";

	stream1Names[9] = "Kelowna";
	stream1URLs[9]  = "http://icy1.abacast.com/cbc-r1kelowna-96.m3u";

	stream1Names[10] = "Labrador";
	stream1URLs[10]  = "http://icy1.abacast.com/cbc-r1goosebay-96.m3u";

	stream1Names[11] = "London";
	stream1URLs[11]  = "http://icy1.abacast.com/cbc-r1london-96.m3u";

	stream1Names[12] = "Moncton";
	stream1URLs[12]  = "http://icy1.abacast.com/cbc-r1moncton-96.m3u";

	stream1Names[13] = "Montreal";
	stream1URLs[13]  = "http://icy1.abacast.com/cbc-r1montreal-96.m3u";

	stream1Names[14] = "Ottawa";
	stream1URLs[14]  = "http://icy1.abacast.com/cbc-r1ottawa-96.m3u";

	stream1Names[15] = "Pr George";
	stream1URLs[15]  = "http://icy1.abacast.com/cbc-r1princegeorge-96.m3u";

	stream1Names[16] = "Quebec";
	stream1URLs[16]  = "http://icy1.abacast.com/cbc-r1quebeccity-96.m3u";
	
	stream1Names[17] = "Regina";
	stream1URLs[17]  = "http://icy1.abacast.com/cbc-r1regina-96.m3u";

	stream1Names[18] = "St John";
	stream1URLs[18]  = "http://icy1.abacast.com/cbc-r1saintjohn-96.m3u";

	stream1Names[19] = "St Johns";
	stream1URLs[19]  = "http://icy1.abacast.com/cbc-r1stjohns-96.m3u";
	
	stream1Names[20] = "Sudbury";
	stream1URLs[20]  = "http://icy1.abacast.com/cbc-r1sudbury-96.m3u";

	stream1Names[21] = "Sydney";
	stream1URLs[21]  = "http://icy1.abacast.com/cbc-r1sydney-96.m3u";

	stream1Names[22] = "Thunder Bay";
	stream1URLs[22]  = "http://icy1.abacast.com/cbc-r1thunderbay-96.m3u";
	
	stream1Names[23] = "Toronto";
	stream1URLs[23]  = "http://icy1.abacast.com/cbc-r1toronto-96.m3u";

	stream1Names[24] = "Vancouver";
	stream1URLs[24]  = "http://icy1.abacast.com/cbc-r1vancouver-96.m3u";

	stream1Names[25] = "Victoria";
	stream1URLs[25]  = "http://icy1.abacast.com/cbc-r1victoria-96.m3u";

	stream1Names[26] = "Whitehorse";
	stream1URLs[26]  = "http://icy1.abacast.com/cbc-r1whitehorse-96.m3u";

	stream1Names[27] = "Windsor";
	stream1URLs[27]  = "http://icy1.abacast.com/cbc-r1windsor-96.m3u";

	stream1Names[28] = "Winnipeg";
	stream1URLs[28]  = "http://icy1.abacast.com/cbc-r1winnipeg-96.m3u";

	stream1Names[29] = "Yellowknife";
	stream1URLs[29]  = "http://icy1.abacast.com/cbc-r1yellowknife-96.m3u";

	var stream1Count = stream1Names.length;

	System.Gadget.Settings.write("stream1Count", stream1Count);

	for (i=0;i<stream1Count;i++)
	{
		System.Gadget.Settings.writeString("stream1"+i.toString(), stream1Names[i]);
		System.Gadget.Settings.writeString("url1"+i.toString(),  stream1URLs[i]);
	}
}

function initStreamList2()
{
	stream2Names = new Array();
	stream2URLs = new Array();

	stream2Names[0] = "Atlantic";
	stream2URLs[0]  = "http://icy1.abacast.com/cbc-r2halifax-128.m3u";
	
	stream2Names[1] = "Eastern";
	stream2URLs[1]  = "http://icy1.abacast.com/cbc-r2toronto-128.m3u";
	
	stream2Names[2] = "Central";
	stream2URLs[2]  = "http://icy1.abacast.com/cbc-r2winnipeg-128.m3u";
	
	stream2Names[3] = "Mountain";
	stream2URLs[3]  = "http://icy1.abacast.com/cbc-r2edmonton-128.m3u";

	stream2Names[4] = "Pacific";
	stream2URLs[4]  = "http://icy1.abacast.com/cbc-r2vancouver-128.m3u"; 

	stream2Names[5] = "Classical";
	stream2URLs[5]  = "http://icy1.abacast.com/cbc-classicalhi-192.m3u";

	stream2Names[6] = "Jazz";
	stream2URLs[6]  = "http://icy1.abacast.com/cbc-jazzhi-192.m3u";

	stream2Names[7] = "Songwriters";
	stream2URLs[7]  = "http://icy1.abacast.com/cbc-songwriterhi-192.m3u";

	stream2Names[8] = "Composers";
	stream2URLs[8]  = "http://icy1.abacast.com/cbc-canadianclassicalhi-192.m3u";

	stream2Names[9] = "RC Int.";
	stream2URLs[9]  = "http://www.rcinet.ca/rci/includes/rcilive.asx";

	stream2Names[10] = "Radio 3";
	stream2URLs[10]  = "http://radio3.cbc.ca/nmcradio/webradio.m3u";

	stream2Names[11] = "Radio3 Rock";
	stream2URLs[11]  = "http://webradio.cbcradio3.com/rock.m3u";

	stream2Names[12] = "Radio3 Elct";
	stream2URLs[12]  = "http://webradio.cbcradio3.com/electronic.m3u";

	stream2Names[13] = "Radio3 Hphp";
	stream2URLs[13]  = "http://webradio.cbcradio3.com/hiphop.m3u";

	stream2Names[14] = "Radio3 Pop";
	stream2URLs[14]  = "http://webradio.cbcradio3.com/pop.m3u";
	
	var stream2Count = stream2Names.length;

	System.Gadget.Settings.write("stream2Count", stream2Count);

	for (i=0;i<stream2Count;i++)
	{
		System.Gadget.Settings.writeString("stream2"+i.toString(), stream2Names[i]);
		System.Gadget.Settings.writeString("url2"+i.toString(),  stream2URLs[i]);
	}
}


function loadStreamList()
{
	stream1Names = new Array();
	stream1URLs = new Array();
	var stream1Count = 0;

	stream2Names = new Array();
	stream2URLs = new Array();
	var stream2Count = 0;
	
	stream1Count = System.Gadget.Settings.read("stream1Count");
	if (stream1Count > 0)
	{
		for (i=0;i<stream1Count;i++)
		{
			stream1Names[i] = System.Gadget.Settings.readString("stream1"+i.toString());
			stream1URLs[i]  = System.Gadget.Settings.readString("url1"+i.toString());
		}
	}
	else
	{
		initStreamList1();
	}

	
	stream2Count = System.Gadget.Settings.read("stream2Count");
	if (stream2Count > 0)
	{
		for (i=0;i<stream2Count;i++)
		{
			stream2Names[i] = System.Gadget.Settings.readString("stream2"+i.toString());
			stream2URLs[i]  = System.Gadget.Settings.readString("url2"+i.toString());
		}
	}
	else
	{
		initStreamList2();
	}
}

function dockStateChange()
{
	
	if(!System.Gadget.docked) 
    { // undocked
	with(document.body.style)
		width=205,
		height=155;

	switch (System.Gadget.Settings.read("station"))
		{ 
		case 1:  // CBC Radio One
			with(bkgImage.style)
				width=205,
				height=155;
				bkgImage.src = "url(images/bkg1.png)";
			break;	

		case 2:  // CBC Radio 2
			with(bkgImage.style)
				width=205,
				height=155;
				bkgImage.src = "url(images/bkg2.png)";
			break;	

		case 3:  // CBC Radio Canada International
			with(bkgImage.style)
				width=205,
				height=155;
				bkgImage.src = "url(images/bkgrci.png)";
			break;	

		case 4:  // CBC Radio 3
			with(bkgImage.style)
				width=205,
				height=155;
				bkgImage.src = "url(images/bkg3.png)";
			break;

		default:  // CBC Radio 2
			with(bkgImage.style)
				width=205,
				height=155;
				bkgImage.src = "url(images/bkg2.png)";
			break;	
		}
	
	with(playbackStatus.style)
		left=80,
		top=115,
		width=120;
	with(nowPlaying.style)
		left=80,
		top=130,
		width=136;
	with(playbackControls.style)
		left=152,
		top=120;
	controlImageMouse(false);
    } 
    else
    { // docked
	with(document.body.style)
		width=135,
		height=63;

	switch (System.Gadget.Settings.read("station"))
		{ 
		case 1:  // CBC Radio One
			with(bkgImage.style)
				width=130,
				height=68;
				bkgImage.src = "images/bkg1_docked.png";
			break;	

		case 2:  // CBC Radio 2
			with(bkgImage.style)
				width=130,
				height=68;
				bkgImage.src = "images/bkg2_docked.png";
			break;	

		case 3:  // CBC Radio Canada International
			with(bkgImage.style)
				width=130,
				height=68;
				bkgImage.src = "images/bkgrci_docked.png";
			break;	

		case 4:  // CBC Radio 3
			with(bkgImage.style)
				width=130,
				height=68;
				bkgImage.src = "images/bkg3_docked.png";
			break;	

		Default:  // CBC Radio 2
			with(bkgImage.style)
				width=130,
				height=68;
				bkgImage.src = "images/bkg2_docked.png";
			break;	
		}
	
	with(playbackStatus.style)
		left=46,
		top=35,
		width=80;
	with(nowPlaying.style)
		left=46,
		top=46,
		width=100;
	with(playbackControls.style)
		left=100,
		top=38;
	controlImageMouse(false);
    }
}

function settingsClosed() 
{
	//loadCurrentStream();
	//controlImageMouse(false);
	loadMain();
}

function controlImageClick()
{		
	if (controlImage.src.indexOf("stop") > 0)
	{
		mediaPlayer.controls.stop();
	}
	else
	{
		mediaPlayer.controls.play();
	}
}

function controlImageMouse(isMouseOn)
{
	var isDocked = System.Gadget.docked;
	if (controlImage.src.indexOf("stop") > 0)
	{
		controlImage.src = "images/stop" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
	}
	else
	{
		controlImage.src = "images/play" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
	}
}


function playStateChange(newstate)
{
	
	switch (newstate){ 
	case 1:  // Stopped
		playbackStatus.innerHTML = "Stopped";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;

	case 2:  // Paused
		playbackStatus.innerHTML = "Paused";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;
	
	case 3:  // Playing
		playbackStatus.innerHTML = "Playing";
		controlImage.src = controlImage.src.replace(/play/, "stop");
		break;

	case 6:  // Buffering
		playbackStatus.innerHTML = "Buffering";
		break;

	case 7:  // Waiting
		playbackStatus.innerHTML = "Waiting";
		break;

	case 8:  // Media Ended
		playbackStatus.innerHTML = "Media Ended";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;

	case 9:  // Transitioning
		playbackStatus.innerHTML = "Connecting";
		break;

	case 10: // Ready
		playbackStatus.innerHTML = "Ready";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;

	case 11: // Reconnecting
		playbackStatus.innerHTML = "Reconnecting";
		break;
	}
}